import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Directive, Output, HostListener, Component, Input, NgModule } from '@angular/core';
import * as i1 from '@angular/common/http';
import { HttpClientModule } from '@angular/common/http';
import * as i3 from '@angular/common';
import { CommonModule } from '@angular/common';

class NgSuperSelectService {
    constructor(http) {
        this.http = http;
    }
    getOptions(url) {
        return this.http.get(url);
    }
}
NgSuperSelectService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: NgSuperSelectService, deps: [{ token: i1.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
NgSuperSelectService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: NgSuperSelectService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: NgSuperSelectService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1.HttpClient }]; } });

class ClickOutsideDirective {
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.clickOutside = new EventEmitter();
    }
    onClick(target) {
        const clickedInside = this.elementRef.nativeElement.contains(target);
        if (!clickedInside) {
            this.clickOutside.emit();
        }
    }
}
ClickOutsideDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: ClickOutsideDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
ClickOutsideDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.6", type: ClickOutsideDirective, selector: "[clickOutside]", outputs: { clickOutside: "clickOutside" }, host: { listeners: { "document:click": "onClick($event.target)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: ClickOutsideDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[clickOutside]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { clickOutside: [{
                type: Output
            }], onClick: [{
                type: HostListener,
                args: ['document:click', ['$event.target']]
            }] } });

class NgSuperSelectComponent {
    constructor(ngSuperSelectService) {
        this.ngSuperSelectService = ngSuperSelectService;
        this.placeholder = "";
        this.isSearchable = false;
        this.isMultiSelectable = false;
        this.optionArray = [];
        this.isDataObject = true;
        this.noOptionMessage = "";
        this.showDoneButton = true;
        this.disable = false;
        this.apiUrl = "";
        this.delay = 400;
        this.apiOnSearch = false;
        this.changeSuperSelect = new EventEmitter();
        this.isOptionShown = false;
        this.displayOptionArray = [];
        this.id = `ngSuperSelectSearchInput${Math.floor(100000 + Math.random() * 900000)}`;
        this.containerId = `ngSuperSelectContainer${Math.floor(100000 + Math.random() * 900000)}`;
        this.gettingNewData = false;
    }
    ngOnInit() {
        if (this.apiUrl) {
            this.getOptions(true);
        }
        else {
            this.displayOptionArray = [...this.optionArray];
            this.selectedData = this.preSelectData ?? (this.isMultiSelectable ? [] : null);
            if (this.selectedData !== undefined && this.selectedData !== null && !this.isMultiSelectable) {
                this.changeSelectedData(this.selectedData);
            }
        }
    }
    getOptions(isFirstTimeApiCall = false) {
        if (this.gettingNewData)
            this.request.unsubscribe();
        this.gettingNewData = true;
        const element = this.getInputElement();
        const searchKey = element?.value.toLowerCase() ?? '';
        this.request = this.ngSuperSelectService.getOptions(`${this.apiUrl}${this.apiOnSearch ? searchKey : ''}`).subscribe({
            next: (response) => {
                const data = !this.responseKey ? response : this.getDataFromResponse(response);
                this.displayOptionArray = data;
                this.optionArray = data;
                this.gettingNewData = false;
                this.selectedData = this.preSelectData ?? (this.isMultiSelectable ? [] : null);
                if (this.selectedData !== undefined && this.selectedData !== null && !this.isMultiSelectable) {
                    this.changeSelectedData(this.selectedData);
                }
            },
            error: () => {
                this.gettingNewData = false;
                this.displayOptionArray = [];
            }
        });
    }
    getDataFromResponse(response) {
        this.responseKey.split(".").forEach(key => {
            response = response[key];
        });
        return response;
    }
    dropDownClicked() {
        if (!this.isOptionShown && !this.disable)
            this.isOptionShown = true;
    }
    get getPlaceHolder() {
        return (this.placeholder || (this.isSearchable ? 'Type here to search' : 'Please select a option'));
    }
    search() {
        try {
            const element = this.getInputElement();
            const searchKey = element.value.toLowerCase();
            if (this.lastApiKeyTerm !== searchKey) {
                this.lastApiKeyTerm = searchKey;
                if (!this.apiUrl || !this.apiOnSearch) {
                    if (!this.isMultiSelectable)
                        this.changeSelectedData(null);
                    if (this.isDataObject && (!this.bindName || !this.bindValue)) {
                        alert("Please pass bindName && bindValue key");
                    }
                    else {
                        this.displayOptionArray = [...this.optionArray].filter(data => (this.isDataObject ? (data[this.bindName] ?? '').toLowerCase().includes(searchKey) : (data ?? '').toLowerCase().includes(searchKey)));
                    }
                }
                else if (this.apiOnSearch) {
                    clearTimeout(this.debounce);
                    this.debounce = setTimeout(() => {
                        this.getOptions();
                    }, this.delay);
                }
            }
        }
        catch (error) {
            alert("Something went wrong with super-select, check console");
            console.log(error);
        }
    }
    getBindName(value) {
        this.isOptionShown = false;
        return this.isDataObject ? this.displayOptionArray.find(data => data[this.bindValue] === value)[this.bindName] : value;
    }
    changeSelectedData(value) {
        if (this.selectedData !== value) {
            this.selectedData = value;
            this.changeSuperSelect.emit(value);
        }
        if (value !== null) {
            this.closeOption();
            const element = this.getInputElement();
            if (element)
                element.value = this.getSelectedDataName(value) ?? null;
            else
                setTimeout(() => {
                    this.changeSelectedData(value);
                }, 0);
        }
    }
    addDataInSelectedData(value) {
        if (!this.selectedData?.find((data) => data === value)) {
            this.changeSuperSelect.emit([...this.selectedData, value]);
            this.selectedData.push(value);
        }
        this.clear();
    }
    closeOption() {
        this.isOptionShown = false;
    }
    isDataSelected(value) {
        return this.isMultiSelectable ? this.selectedData.find((data) => data === value) : this.selectedData === value;
    }
    optionClicked(value) {
        this.isMultiSelectable ? this.addDataInSelectedData(value) : this.changeSelectedData(value);
    }
    clear(isClicked = false) {
        const element = this.getInputElement();
        element.value = "";
        if (this.isMultiSelectable)
            element?.focus();
        if (!this.isMultiSelectable) {
            this.changeSelectedData(null);
        }
        this.search();
        if (isClicked) {
            setTimeout(() => {
                this.isOptionShown = true;
            }, 0);
        }
    }
    getSelectedDataName(value) {
        const record = this.optionArray.find((data) => this.isDataObject ? data[this.bindValue] === value : data === value);
        return this.isDataObject ? (record ? record[this.bindName] : null) : record;
    }
    canShowClearIcon() {
        const element = this.getInputElement();
        return element.value;
    }
    getInputElement() {
        return document.getElementById(this.id);
    }
    removeValue(index) {
        let newSelectedData = [...this.selectedData];
        newSelectedData.splice(index, 1);
        this.selectedData = newSelectedData;
        this.changeSuperSelect.emit(newSelectedData);
    }
    clickOutside() {
        if (this.isOptionShown) {
            this.closeOption();
            if (this.isSearchable) {
                if (this.isMultiSelectable || (!this.isMultiSelectable && !this.selectedData)) {
                    this.clear();
                }
            }
        }
    }
    isActiveElement() {
        const element = this.getInputElement();
        return element === document.activeElement;
    }
    focusOut() {
        const element = this.getInputElement();
        element?.blur();
    }
    getOptionContainerWidth() {
        const element = document.getElementById(this.containerId);
        ;
        return {
            width: `${element?.offsetWidth}px`
        };
    }
}
NgSuperSelectComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: NgSuperSelectComponent, deps: [{ token: NgSuperSelectService }], target: i0.ɵɵFactoryTarget.Component });
NgSuperSelectComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: NgSuperSelectComponent, selector: "ng-super-select", inputs: { placeholder: "placeholder", isSearchable: "isSearchable", isMultiSelectable: "isMultiSelectable", optionArray: "optionArray", bindName: "bindName", bindValue: "bindValue", isDataObject: "isDataObject", noOptionMessage: "noOptionMessage", preSelectData: "preSelectData", showDoneButton: "showDoneButton", disable: "disable", apiUrl: "apiUrl", responseKey: "responseKey", delay: "delay", apiOnSearch: "apiOnSearch" }, outputs: { changeSuperSelect: "changeSuperSelect" }, ngImport: i0, template: "<div (clickOutside)=\"clickOutside();focusOut()\" [id]=\"containerId\" class=\"ng-super-select-container\">\n  <div (click)=\"dropDownClicked()\" class=\"ng-super-select-field\"\n    [ngClass]=\"{'ng-super-select-dropdown-field': !isSearchable, 'active': (isActiveElement() && !disable), 'ng-super-select-disable': disable}\">\n    <ng-container *ngIf=\"isMultiSelectable\">\n      <div class=\"ng-super-select-selected-data-options\" *ngFor=\"let item of selectedData; let i = index;\">\n        <span> {{getSelectedDataName(item)}} </span>\n        <button *ngIf=\"!disable\" (click)=\"removeValue(i)\" class=\"ng-super-select-remove-selected-data\"> x </button>\n      </div>\n    </ng-container>\n    <input type=\"search\" [readonly]=\"!isSearchable || disable\" [id]=\"id\" [placeholder]=\"getPlaceHolder\"\n      (input)=\"search()\" type=\"text\" class=\"ng-super-select-input\">\n    <span *ngIf=\"(isSearchable && canShowClearIcon()) && !disable\" class=\"ng-super-select-clear\"\n      (click)=\"clear(true)\">x</span>\n    <span *ngIf=\"!isSearchable\" class=\"ng-super-select-down-icon\"></span>\n  </div>\n  <div [ngStyle]=\"getOptionContainerWidth()\" class=\"ng-super-select-option-button-container\" *ngIf=\"isOptionShown\">\n    <div class=\"ng-super-select-option-container\">\n      <ng-container *ngIf=\"!isDataObject || (isDataObject && bindName && bindValue)\">\n        <!-- <ng-container *ngIf=\"!isMultiSelectable\"> -->\n        <option (click)=\"optionClicked(isDataObject ? item[bindValue] : item);\" class=\"ng-super-select-option\"\n          [ngClass]=\"{'active': isDataSelected(isDataObject ? item[bindValue] : item)}\"\n          *ngFor=\"let item of displayOptionArray\">\n          {{isDataObject ? item[bindName] : item}}\n        </option>\n        <li (click)=\"clear()\" class=\"ng-super-select-option\" *ngIf=\"displayOptionArray && !displayOptionArray.length\">\n          {{noOptionMessage ||\n          'No data available'}}</li>\n      </ng-container>\n      <ng-container *ngIf=\"isDataObject && (!bindName || !bindValue) \">\n        <li class=\"ng-super-select-option\">Please pass bindName && bindValue key</li>\n      </ng-container>\n    </div>\n    <div class=\"ng-super-select-button-section\" *ngIf=\"isMultiSelectable && showDoneButton\">\n      <button (click)=\"closeOption(); clear();focusOut()\" class=\"ng-super-select-action-button\">Done</button>\n    </div>\n  </div>\n</div>\n", styles: [".ng-super-select-container{margin:20px 0}.ng-super-select-field{display:flex;align-items:baseline;flex-wrap:wrap;border-radius:6px;background:#f0f0f0}.ng-super-select-field.active{border:1px solid}input.ng-super-select-input{padding:15px 10px;min-width:250px;flex:1 0 250px;border-radius:6px;background:#f0f0f0;border:none}input.ng-super-select-input:focus{box-shadow:none;border-color:transparent;outline:none}.ng-super-select-down-icon{width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-top:5px solid;margin:0 4px;position:relative;right:2px}.ng-super-select-clear{position:relative;right:15px;cursor:pointer;width:0}.ng-super-select-option-container{margin:0;padding:0;max-height:240px;overflow-y:auto}.ng-super-select-option-button-container{padding:15px 0;z-index:5;border-radius:6px;background:#fff;display:flex;flex-direction:column;position:absolute;border:1px solid #f2f2f2;box-shadow:0 2px 4px -1px #0003,0 4px 5px #00000024,0 1px 10px #0000001f}.ng-super-select-option{list-style:none;cursor:pointer;padding:10px;-webkit-user-select:none;user-select:none}.ng-super-select-option.active,.ng-super-select-option:hover{color:#9d73b5;background:#f5f5f5}.ng-super-select-button-section{display:flex;justify-content:flex-end}.ng-super-select-button-section button{width:49%}.ng-super-select-selected-data-option-container{margin:20px 0;display:flex;flex-wrap:wrap;word-wrap:break-word}.ng-super-select-selected-data-options{padding:7px 8px 7px 12px;background:#e0e0e0;color:#000000de;border-radius:16px;align-items:center;cursor:default;margin-left:4px;margin-bottom:4px}.ng-super-select-remove-selected-data{border-radius:100%;width:16px;font-size:14px;padding:0;opacity:.5;margin-left:14px;border:none;background:#929292;color:#e0e0e0;font-weight:700;cursor:pointer}.ng-super-select-action-button{box-shadow:0 0 #0003,0 0 #00000024,0 0 #0000001f;border:1px solid currentColor;line-height:34px;box-sizing:border-box;position:relative;-webkit-user-select:none;user-select:none;cursor:pointer;outline:none;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible}.ng-super-select-disable,.ng-super-select-disable>input{opacity:.6;cursor:default}\n"], directives: [{ type: ClickOutsideDirective, selector: "[clickOutside]", outputs: ["clickOutside"] }, { type: i3.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i3.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: NgSuperSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ng-super-select', template: "<div (clickOutside)=\"clickOutside();focusOut()\" [id]=\"containerId\" class=\"ng-super-select-container\">\n  <div (click)=\"dropDownClicked()\" class=\"ng-super-select-field\"\n    [ngClass]=\"{'ng-super-select-dropdown-field': !isSearchable, 'active': (isActiveElement() && !disable), 'ng-super-select-disable': disable}\">\n    <ng-container *ngIf=\"isMultiSelectable\">\n      <div class=\"ng-super-select-selected-data-options\" *ngFor=\"let item of selectedData; let i = index;\">\n        <span> {{getSelectedDataName(item)}} </span>\n        <button *ngIf=\"!disable\" (click)=\"removeValue(i)\" class=\"ng-super-select-remove-selected-data\"> x </button>\n      </div>\n    </ng-container>\n    <input type=\"search\" [readonly]=\"!isSearchable || disable\" [id]=\"id\" [placeholder]=\"getPlaceHolder\"\n      (input)=\"search()\" type=\"text\" class=\"ng-super-select-input\">\n    <span *ngIf=\"(isSearchable && canShowClearIcon()) && !disable\" class=\"ng-super-select-clear\"\n      (click)=\"clear(true)\">x</span>\n    <span *ngIf=\"!isSearchable\" class=\"ng-super-select-down-icon\"></span>\n  </div>\n  <div [ngStyle]=\"getOptionContainerWidth()\" class=\"ng-super-select-option-button-container\" *ngIf=\"isOptionShown\">\n    <div class=\"ng-super-select-option-container\">\n      <ng-container *ngIf=\"!isDataObject || (isDataObject && bindName && bindValue)\">\n        <!-- <ng-container *ngIf=\"!isMultiSelectable\"> -->\n        <option (click)=\"optionClicked(isDataObject ? item[bindValue] : item);\" class=\"ng-super-select-option\"\n          [ngClass]=\"{'active': isDataSelected(isDataObject ? item[bindValue] : item)}\"\n          *ngFor=\"let item of displayOptionArray\">\n          {{isDataObject ? item[bindName] : item}}\n        </option>\n        <li (click)=\"clear()\" class=\"ng-super-select-option\" *ngIf=\"displayOptionArray && !displayOptionArray.length\">\n          {{noOptionMessage ||\n          'No data available'}}</li>\n      </ng-container>\n      <ng-container *ngIf=\"isDataObject && (!bindName || !bindValue) \">\n        <li class=\"ng-super-select-option\">Please pass bindName && bindValue key</li>\n      </ng-container>\n    </div>\n    <div class=\"ng-super-select-button-section\" *ngIf=\"isMultiSelectable && showDoneButton\">\n      <button (click)=\"closeOption(); clear();focusOut()\" class=\"ng-super-select-action-button\">Done</button>\n    </div>\n  </div>\n</div>\n", styles: [".ng-super-select-container{margin:20px 0}.ng-super-select-field{display:flex;align-items:baseline;flex-wrap:wrap;border-radius:6px;background:#f0f0f0}.ng-super-select-field.active{border:1px solid}input.ng-super-select-input{padding:15px 10px;min-width:250px;flex:1 0 250px;border-radius:6px;background:#f0f0f0;border:none}input.ng-super-select-input:focus{box-shadow:none;border-color:transparent;outline:none}.ng-super-select-down-icon{width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-top:5px solid;margin:0 4px;position:relative;right:2px}.ng-super-select-clear{position:relative;right:15px;cursor:pointer;width:0}.ng-super-select-option-container{margin:0;padding:0;max-height:240px;overflow-y:auto}.ng-super-select-option-button-container{padding:15px 0;z-index:5;border-radius:6px;background:#fff;display:flex;flex-direction:column;position:absolute;border:1px solid #f2f2f2;box-shadow:0 2px 4px -1px #0003,0 4px 5px #00000024,0 1px 10px #0000001f}.ng-super-select-option{list-style:none;cursor:pointer;padding:10px;-webkit-user-select:none;user-select:none}.ng-super-select-option.active,.ng-super-select-option:hover{color:#9d73b5;background:#f5f5f5}.ng-super-select-button-section{display:flex;justify-content:flex-end}.ng-super-select-button-section button{width:49%}.ng-super-select-selected-data-option-container{margin:20px 0;display:flex;flex-wrap:wrap;word-wrap:break-word}.ng-super-select-selected-data-options{padding:7px 8px 7px 12px;background:#e0e0e0;color:#000000de;border-radius:16px;align-items:center;cursor:default;margin-left:4px;margin-bottom:4px}.ng-super-select-remove-selected-data{border-radius:100%;width:16px;font-size:14px;padding:0;opacity:.5;margin-left:14px;border:none;background:#929292;color:#e0e0e0;font-weight:700;cursor:pointer}.ng-super-select-action-button{box-shadow:0 0 #0003,0 0 #00000024,0 0 #0000001f;border:1px solid currentColor;line-height:34px;box-sizing:border-box;position:relative;-webkit-user-select:none;user-select:none;cursor:pointer;outline:none;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible}.ng-super-select-disable,.ng-super-select-disable>input{opacity:.6;cursor:default}\n"] }]
        }], ctorParameters: function () { return [{ type: NgSuperSelectService }]; }, propDecorators: { placeholder: [{
                type: Input
            }], isSearchable: [{
                type: Input
            }], isMultiSelectable: [{
                type: Input
            }], optionArray: [{
                type: Input
            }], bindName: [{
                type: Input
            }], bindValue: [{
                type: Input
            }], isDataObject: [{
                type: Input
            }], noOptionMessage: [{
                type: Input
            }], preSelectData: [{
                type: Input
            }], showDoneButton: [{
                type: Input
            }], disable: [{
                type: Input
            }], apiUrl: [{
                type: Input
            }], responseKey: [{
                type: Input
            }], delay: [{
                type: Input
            }], apiOnSearch: [{
                type: Input
            }], changeSuperSelect: [{
                type: Output
            }] } });

class NgSuperSelectModule {
}
NgSuperSelectModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: NgSuperSelectModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgSuperSelectModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: NgSuperSelectModule, declarations: [NgSuperSelectComponent,
        ClickOutsideDirective], imports: [CommonModule,
        HttpClientModule], exports: [NgSuperSelectComponent] });
NgSuperSelectModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: NgSuperSelectModule, imports: [[
            CommonModule,
            HttpClientModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: NgSuperSelectModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NgSuperSelectComponent,
                        ClickOutsideDirective
                    ],
                    imports: [
                        CommonModule,
                        HttpClientModule
                    ],
                    exports: [
                        NgSuperSelectComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of ng-super-select
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgSuperSelectComponent, NgSuperSelectModule, NgSuperSelectService };
//# sourceMappingURL=ng-super-select.mjs.map
